{% extends 'base.html' %}
{% from 'macros.html' import delete_button %}
{% from 'macros.html' import config_stats_table %}
{% block content %}
<h1 class="display-4">{{server.name}}
{%- if server.auto_start %}
<span class="badge badge-{%- if server.running %}success{%-else %}danger{%-endif-%}">Auto Start Enabled</span>
{%-else %}
{%- if server.running %}
<span class="badge badge-success">Running</span>
{%-else %}
<span class="badge badge-danger">Not running</span>
{%-endif-%}
{%-endif-%}



</h1>
<div class="mb-3">
{% if server.running %}
<a href="{{ url_for('servers.stop', id=server.id, next=request.path) }}" class="btn btn-sm btn-warning">Stop</a>
{% else %}
<a href="{{ url_for('servers.start', id=server.id, next=request.path) }}" class="btn btn-sm btn-info">Start</a>
{% endif%}
<a href="{{ url_for('servers.create', id=server.id) }}" class="btn btn-sm btn-secondary">Edit</a>
{{ delete_button(url_for('servers.delete', id=server.id, next=request.path), server.name) }}
</div>
<div class="card mb-3">
  <!-- <div class="card-header"></div> -->
  <div class="card-body">
    <h5 class="card-title">{{server.protocol.type|replace('_', ' ')|title}} Sender</h5>
    {{config_stats_table(server.protocol, server.stats['sender'])}}
    {% set producers = server.stats['producers'] or [] %}
    {% for content in server.content %}
    {% set producer = producers[loop.index] or {} %}
    <h5 class="card-title">{{content.type|replace('_', ' ')|title}} Producer</h5>
    {{config_stats_table(content, producer)}}
    {% endfor %}
  </div>
  <div class="card-footer">
    <small class="text-muted" data-toggle="tooltip" data-placement="bottom" title="{{server.created}}">Created {{momentjs(server.created).fromNow() }}</small>
  </div>
</div>

<div class="card mb-3">
  <div class="card-header">Raw Config</div>
    <div class="card-body">
      <pre id="server-config" class="card-text">{{server.config_string | safe}}</pre>
  </div>
</div>
<div class="card mb-3">
  <div class="card-header">Raw Stats</div>
  <div class="card-body">
    <pre id="server-stats" class="card-text">{{ server.stats_string }}</pre>
  </div>
  <div class="card-footer">
    <small class="text-muted" data-toggle="tooltip" data-placement="bottom" title="{{server.last_updated}}">Updated {{momentjs(server.last_updated).fromNow() }}</small>
  </div>
</div>
{% endblock %}

{% block js %}
<script>
$( document ).ready(function() {
    function syntaxHighlight(element) {
        json = JSON.parse(element.innerHTML)

        json = JSON.stringify(json, null, 2);
        json = json.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
        element.innerHTML = json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
            var cls = 'json-number';
            if (/^"/.test(match)) {
                if (/:$/.test(match)) {
                    cls = 'json-key';
                } else {
                    cls = 'json-string';
                }
            } else if (/true|false/.test(match)) {
                cls = 'json-boolean';
            } else if (/null/.test(match)) {
                cls = 'json-null';
            }
            return '<span class="' + cls + '">' + match + '</span>';
        });
    }
    syntaxHighlight(document.getElementById("server-config"));
    syntaxHighlight(document.getElementById("server-stats"));

});
</script>

{% endblock %}